#!/usr/local/bin/wish
# Set this first line if wish is not in your path
###############################################################################
#
# DESCRIPTION
#
# This file contains the wish file used by mom_review
#
##############################################################################
# REVISIONS
#   Date       Who              Reason
#   7/31/98    whb              remove './' to make independent
##############################################################################
###############################################################################
#
#  Daten fuer BOX 1 ermitteln und ausgeben
#
###############################################################################
proc show_box1 {} \
{
  global box1 box2 LIST_DBG STR_LG VAR_SEARCH
  global box2_flag 
  set VAR_FLAG 0

  set event_index  [ $box2 curselection ]

  if { [ string length $event_index  ] == 0 } \
  {
     
      set VAR_SEARCH mom_tool_name 
      set VAR_FLAG 1

  } else \
  {
      set event_string [ $box2 get $event_index ]

      if { [string index $event_string 0] == "V" } \
      {
          set POS  [expr [string first "=" $event_string ] -2 ]
          set VAR_SEARCH [string range $event_string 2 $POS]
          set box2_flag 1
          set VAR_FLAG 1
      }
  }

  if { $VAR_FLAG == 1 } \
  {
     # Daten in Box1 loeschen
     # -----------------------
     $box1 delete 0 end
   
     # Label in Box1 setzen
     # -----------------------
     set TEXT "  Var: "
     set POS [ expr $STR_LG -10 ]
#     .box1.text config -text "[ format %-${POS}s $TEXT ]proc in Post  = $VAR_SEARCH"
     .box1.text config -text "$TEXT  =  $VAR_SEARCH"
     update idletasks
         
     # Daten in Box1 ausgeben
     # -----------------------
     foreach LINE_ENV  $LIST_DBG \
     {
         set EVENT [ string trimleft [lindex $LINE_ENV 0 ] "E " ]
         set POS   [expr [string length $EVENT ] -2 ]
         set EVENT_OUT  [string range $EVENT 0 [ expr $POS -1 ] ]
         set VAR_OUT [string range $EVENT $POS end ]
         foreach LINE_VAR  $LINE_ENV \
         {
             # nach variablen suchen
             set POS  [expr [string first "=" $LINE_VAR ] -2 ]
             set LINE [string range $LINE_VAR 2 $POS]
             if { [string compare "$VAR_SEARCH" "$LINE"] == 0 } \
             {
                set VAR_OUT "$VAR_OUT [string range $LINE_VAR [expr $POS + 2 ] end ]"
             }
         }

         $box1 insert end "[ format %-${STR_LG}s $EVENT_OUT ] $VAR_OUT "
#        $box1 insert end "$EVENT_OUT $VAR_OUT" 
    }
  } 
}
###############################################################################
#
#  Daten fuer BOX 2 ermitteln und ausgeben
#
###############################################################################
proc show_box2 {}\
{
  global box1 box2 box3 LIST_DBG VAR_SEARCH LIST_OUT
  global box3_flag box2_flag index
  set start_hig 0
  set end_hig 0

  if {$box3_flag == 1} \
  {
      set event_index $index
      $box1 yview $index
  } else \
  {
      set event_index  [ $box1 curselection ]
  }

  set event_string [ $box1 get $event_index ]
# puts stdout "box $box1 event $event_index"
  # evt.variable aus event_string weglesen
  # --------------------------------------
  set TEST [ expr [ string first "=" $event_string  ] -1 ]
  if { $TEST > 0 } \
   { set event_string [ string  range $event_string 0 $TEST ]
   }
  
  # evt. "NOT in POST" an  event_string anhaengen
  # ---------------------------------------------
  set POS  [ expr [ string length $event_string ] - 3 ]
  set TEST [ string range $event_string  $POS [expr $POS + 1 ] ]
  set DUM  "[ string range $event_string 0 [expr $POS - 1 ]]"

  if { [ string compare "$TEST"  "NO" ] == 0  } \
   { set event_string $DUM
   }
  

  # Daten in Box2 loeschen
  # -----------------------
  $box2 delete 0 end

  # Label in Box2 setzen
  # -----------------------
  
  set FIN_STR [ string range $event_string 0 [expr $POS - 3 ]]
  .box2.text config -text "  Event : $FIN_STR"
  update idletasks
      
  # Daten in Box2 ausgeben
  # -----------------------
  set EVENT [ lindex $LIST_DBG $event_index ]
  foreach LINE  $EVENT  \
   { 
           $box2 insert end "$LINE"
   }
  
  if {$box3_flag != 1} \
  {
     for {set i 0} {$i <= $event_index} {incr i} \
     {
        set OUTPUT [ lindex $LIST_OUT $i ]
        foreach NAME $OUTPUT \
        {
           incr end_hig
        }
     }

     set OUTPUT [ lindex $LIST_OUT $event_index ]
     foreach NAME $OUTPUT \
     {
          incr start_hig
     }
      
     set start_hig [expr $end_hig - $start_hig ]
#    puts "start_hig = $start_hig"
     set end_hig [expr $end_hig - 1]
#    puts "end_hig = $end_hig"
     $box3 selection set $start_hig $end_hig
     $box3 yview [ expr $start_hig - 3]     
#    puts "into show_box2 box2_flag = $box2_flag"
     if {$box2_flag == 1} \
     {
          show_box1
          set box2_flag 0
     }
  }
     set box3_flag 0
}  
###############################################################################
#
#  Daten fuer BOX 3 ermitteln und ausgeben
#
###############################################################################
proc show_box3 {}\
{
  global box1 box2 box3 LIST_DBG VAR_SEARCH LIST_OUT
  global box3_flag index

  set event_index  [ $box3 curselection ]
  set event_string [ $box3 get $event_index ]
  set main_index 0
  set sub_index 0
  set break_flag 0
  
  foreach ELEMENT $LIST_OUT \
  {
     foreach NAME $ELEMENT \
     {
       if { $sub_index == $event_index} \
       {
          set break_flag 1
          break
       }
       incr sub_index
     }
     if {$break_flag == 1} \
     {
         break
     }
     incr main_index
  }

   .box3.text config -text "       Post Output"
#  puts "main_index = $main_index"
#  $box1 selection set $main_index $main_index
   set index $main_index
   set box3_flag 1
   show_box2

}  

###############################################################################
#
# proc user_exit
#
###############################################################################
proc user_exit {} \
{
#  puts stdout "================= debug finish ===================="
  exit
}

###############################################################################
#
#                           H A U P T P R O G R A M M 
#
###############################################################################
# 
# this sets the output file variable
# IT MUST BE SET THE SAME IN THE debug_listbox.tcl SCRIPT
#
set debug_data "mom_review_all.out"
set proc_data  "mom_review_proc.out"
set box3_flag 0
set box2_flag 0
set index 0

#  Start create window
#----------------------
wm title . "UG Post Debug lister"


frame .box1
menubutton .box1.text -text "List of event's:"
scrollbar .box1.y -orient vertical -command [list .box1.pick yview]
scrollbar .box1.x -orient horizontal -command [list .box1.pick xview]
set box1 [listbox .box1.pick -width 30 -height 30 -borderwidth 5 -bg white \
         -fg black -relief sunken -setgrid true \
         -selectmode single\
         -yscrollcommand [list .box1.y set]\
         -xscrollcommand [list .box1.x set] ]

frame .box2
menubutton .box2.text -text "please pick one event in the left window"
scrollbar .box2.y -orient vertical -command [list .box2.pick yview]
scrollbar .box2.x -orient horizontal -command [list .box2.pick xview]
set box2 [listbox .box2.pick -width 30 -height 30 -borderwidth 5 -bg white \
         -fg black -relief sunken -setgrid true \
         -selectmode single\
         -yscrollcommand [list .box2.y set]\
         -xscrollcommand [list .box2.x set] ]

frame .box3
menubutton .box3.text -text "        Post Output "
scrollbar .box3.y -orient vertical -command [list .box3.pick yview]
scrollbar .box3.x -orient horizontal -command [list .box3.pick xview]
set box3 [listbox .box3.pick -width 30 -height 30 -borderwidth 5 -bg white \
         -fg black -relief sunken -setgrid true \
         -selectmode single\
         -yscrollcommand [list .box3.y set]\
         -xscrollcommand [list .box3.x set] ]

frame .buttons 
button .buttons.quit -text "  Exit  " -command user_exit
pack .buttons.quit -side bottom        ;#-fill both 
pack .buttons -side bottom             ;#-fill both 


pack .box1.text  -in .box1  -side top -anchor nw 
pack .box1.x -side bottom  -fill both
pack .box1.pick  -side left -expand 1 -fill both 
pack .box1.y -side right  -fill both

pack .box2.text -in .box2  -side top -anchor nw 
pack .box2.x -side bottom -fill both 
pack .box2.pick  -side left -expand 1 -fill both 
pack .box2.y -side right  -fill both 

pack .box3.text -in .box3  -side top -anchor nw 
pack .box3.x -side bottom  -fill both 
pack .box3.pick  -side left -expand 1 -fill both 
pack .box3.y -side right  -fill both 

pack .box1 .box2 .box3 -side left -expand 1 -fill both 
# pack .box1 .box2 .box3 -side left

bind $box1 <ButtonRelease-1> show_box2
bind $box2 <ButtonRelease-1> show_box1
bind $box3 <ButtonRelease-1> show_box3

# Procdaten auf Listen einlesen
# -------------------------
if [catch {open $proc_data r} FP1] \
 { 
     puts stdout " can't open file $proc_data "
     tk_messageBox -type ok -icon error\
     -message "Can't open data file $proc_data"
     exit
 } else \
 { 
#  puts stdout "debug_listbox.tcl: read  $proc_data"
   while { [eof $FP1] != 1 } \
    {  gets $FP1 procline
       lappend LIST_PROC  "$procline"
    }
   close $FP1
#    puts stdout "debug_listbox.tcl: close $proc_data"
 }


# Debugdaten auf Listen einlesen
# ------------------------------
if [catch {open $debug_data r} FP2] \
 { 
    puts stdout " can't open file $debug_data "
    tk_messageBox -type ok -icon error\
                -message "Can't open data file $debug_data"
   exit
 } else \
 { 
   set STR_LG 0
   set output_flag 0
#  puts stdout "debug_listbox.tcl: read  $debug_data"  
   while { [eof $FP2] != 1 } \
    { 
        gets $FP2 dataline
        if { [string index $dataline 0] == "E" } \
         {
            set STR_L [ string length $dataline ]
            if { $STR_L > $STR_LG } { set STR_LG $STR_L }

              # test ob proc in post 
              #---------------------
              if { $output_flag != 0} \
              {
                 if { [ info exists EVENT_OUT ] == 0} \
                  {
                      lappend EVENT_OUT " No Output From Event "
                  }
                 lappend LIST_OUT "$EVENT_OUT"
                 unset EVENT_OUT
              }
               set TEST_STRING [ string trimleft $dataline  "E " ]
               set POS  [expr [string first " " $TEST_STRING ] -1 ]
               set TEST_STRING [ string range $TEST_STRING 0 $POS ]
               set TEST_PROC [ lsearch $LIST_PROC $TEST_STRING ]
               if { $TEST_PROC >= 0 } { set TEST_PROC "+ " } { set TEST_PROC "NO" }
               set fin_dataline "$dataline $TEST_PROC"
               if { [ info exists LIST_ENV ] == 0 } \
                {
                   lappend LIST_ENV  "Variables Are Not Available"
                }
                   lappend LIST_DBG  "[ list $fin_dataline ] $LIST_ENV"
                unset LIST_ENV                         ;# alles Loeschen
                set output_flag 1
         } else \
         {
             # variablen einlesen
             if { [string index $dataline 0] == "V" } \
              {
                 lappend LIST_ENV  "$dataline"
              } elseif { [string index $dataline 0] == "O" } \
              {
                 lappend EVENT_OUT "$dataline"
              }
         }
    }

    close $FP2
#   puts stdout "debug_listbox.tcl:close $debug_data"
    global LIST_DBG STR_LG LIST_OUT
 }
#puts stdout $LIST_DBG
# Erster Aufruf Box1
#--------------------
set TEST [ show_box1 ]

foreach OUTPUT $LIST_OUT \
{
  foreach NAME $OUTPUT \
  {
     set TEST [ expr [ string first "=" $NAME ] +2 ]
     if { $TEST > 0 } \
      { set NAME [ string  range $NAME $TEST end]
      }
             $box3 insert end $NAME
  }
}
